from trac.util import escape
from trac.wiki.macros import WikiMacroBase 
from StringIO import StringIO
import csv

__all__ = ['CSVMacro']

class CSVMacro(WikiMacroBase):
    def render_macro(self, req, name, args):
        sniffer = csv.Sniffer()
        args = args.encode('ascii', 'replace')
        reader = csv.reader(StringIO(args), sniffer.sniff(args))
        out = StringIO()
        out.write('<table class="wiki">\n')
        for row in reader:
            out.write('<tr>')
            for col in row:
                out.write('<td>%s</td>' % escape(col))
            out.write('</tr>\n')
        out.write('</table>\n')
        return out.getvalue()
